Xapian: API Documentation: xapian-core: Xapian::BoolWeight Class Reference

# Xapian::BoolWeight Class Reference

Class implementing a "boolean" weighting scheme. More...

Inheritance diagram for Xapian::BoolWeight:

[legend]

List of all members.

## Public Member Functions
| BoolWeight ()
| Construct a BoolWeight.
std::string | name () const
| Return the name of this weighting scheme.
std::string | serialise () const
| Return this object's parameters serialised as a single string.
BoolWeight * | unserialise (const std::string &s) const
| Unserialise parameters.
Xapian::weight | get_sumpart (Xapian::termcount wdf, Xapian::termcount doclen) const
| Calculate the weight contribution for this object's term to a document.
Xapian::weight | get_maxpart () const
| Return an upper bound on what get_sumpart() can return for any document.
Xapian::weight | get_sumextra (Xapian::termcount doclen) const
| Calculate the term-independent weight component for a document.
Xapian::weight | get_maxextra () const
| Return an upper bound on what get_sumextra() can return for any document.

## Detailed Description

Class implementing a "boolean" weighting scheme.

This weighting scheme gives all documents zero weight.

## Constructor & Destructor Documentation

Xapian::BoolWeight::BoolWeight | ( |  | ) | `[inline]`

Construct a BoolWeight.

## Member Function Documentation

Xapian::weight Xapian::BoolWeight::get_maxextra | ( |  | ) | const`[virtual]`

Return an upper bound on what get_sumextra() can return for any document.

This information is used by the matcher to perform various optimisations, so strive to make the bound as tight as possible.

Implements Xapian::Weight.

Xapian::weight Xapian::BoolWeight::get_maxpart | ( |  | ) | const`[virtual]`

Return an upper bound on what get_sumpart() can return for any document.

This information is used by the matcher to perform various optimisations, so strive to make the bound as tight as possible.

Implements Xapian::Weight.

Xapian::weight Xapian::BoolWeight::get_sumextra | ( | Xapian::termcount | doclen | ) | const`[virtual]`

Calculate the term-independent weight component for a document.

The parameter gives information about the document which may be used in the calculations:

Parameters:

  | doclen | The document's length (unnormalised).

Implements Xapian::Weight.

Xapian::weight Xapian::BoolWeight::get_sumpart | ( | Xapian::termcount | wdf,
|  | Xapian::termcount | doclen |
| ) |  |  | const`[virtual]`

Calculate the weight contribution for this object's term to a document.

The parameters give information about the document which may be used in the calculations:

Parameters:

  | wdf | The within document frequency of the term in the document.
  | doclen | The document's length (unnormalised).

Implements Xapian::Weight.

std::string Xapian::BoolWeight::name | ( |  | ) | const`[virtual]`

Return the name of this weighting scheme.

This name is used by the remote backend. It is passed along with the serialised parameters to the remote server so that it knows which class to create.

Return the full namespace-qualified name of your class here - if your class is called FooWeight, return "FooWeight" from this method (Xapian::BM25Weight returns "Xapian::BM25Weight" here).

If you don't want to support the remote backend, you can use the default implementation which simply returns an empty string.

Reimplemented from Xapian::Weight.

std::string Xapian::BoolWeight::serialise | ( |  | ) | const`[virtual]`

Return this object's parameters serialised as a single string.

If you don't want to support the remote backend, you can use the default implementation which simply throws Xapian::UnimplementedError.

Reimplemented from Xapian::Weight.

BoolWeight* Xapian::BoolWeight::unserialise | ( | const std::string & | s | ) | const`[virtual]`

Unserialise parameters.

This method unserialises parameters serialised by the serialise() method and allocates and returns a new object initialised with them.

If you don't want to support the remote backend, you can use the default implementation which simply throws Xapian::UnimplementedError.

Note that the returned object will be deallocated by Xapian after use with "delete". If you want to handle the deletion in a special way (for example when wrapping the Xapian API for use from another language) then you can define a static `operator delete` method in your subclass as shown here: http://trac.xapian.org/ticket/554#comment:1

Parameters:

  | s | A string containing the serialised parameters.

Reimplemented from Xapian::Weight.

The documentation for this class was generated from the following file:

- xapian/weight.h